//############################################
//### Chat mit Win32                       ###
//### Programmiert von Jens Scheffler 2000 ###
//### mailto:j_scheffler@gmx.de            ###
//############################################

//Was wre noch zu verbessern?
//-Cascadierter Server
//-Server Puffert Chat fr eingegangene Meldungen
//-Erweiterte Meldungen bei Verbindungen/Trennen
//-Link auf Homepage im Men
//-Dateien senden per Drag & Drop
//-Serverfunktion automatisch weiterleiten bei beenden
//-Einstellmglichkeiten fr Fonts

//### Includes

#define FD_SETSIZE 64 //Anzahl der Maximalen Serververbindungen
#include <winsock2.h>
#include <winuser.h>
#include <stdio.h>
#include "resource.h"

//### defines
#define MAXINPUT				65536
#define MAXUSERNAMELEN			256
#define MAXSERVERLEN			128
#define MAXPORTLEN				6

#define FENSTERRAND				5
#define BUTTONHOEHE				23
#define BUTTONBREITE			75
#define INPUTBOXHOEHE			50
#define SERVERHOEHE				16
#define SERVERLABELBREITE		40
#define PORTLABELBREITE			27
#define PORTBREITE				40

#define MINWINDOWX				250
#define MINWINDOWY				200

#define REGVERZEICHNIS			"Software\\ChatWin32"
#define STRINGLEN				256
#define FEHLERSTRINGLEN			1024
#define STANDARDSERVER			"localhost"
#define STANDARDPORT			"2048"
#define STANDARDAUTOSENDEN		"True"
#define STANDARDPOPUP			"True"
#define STANDARDAUTOCONNECT		"True"
#define STANDARDSERVERAKTIV		"True"
#define STANDARDSERVERPORT		"2048"
#define MAXBACKLOG				32

#define WM_NEUEDATEN			WM_USER+1

#define FEHLER_NORMAL			0
#define FEHLER_AUSRUFEZEICHEN	1
#define FEHLER_X				2
#define FEHLER_FRAGEZEICHEN		3

//### Globale Variablen
HINSTANCE hInst;
char LetzteEingabe[MAXINPUT];
char UserName[MAXUSERNAMELEN];
long OutputTextLen;
SOCKET ChatSocket;
int PopUp;
int ServerBeenden;
HWND hMainWnd;
int AlteGroesseX, AlteGroesseY;

//### Funktionen
LRESULT ChatFensterCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void Senden();
void DialogInitialisieren();
void UpdateAutoSenden();
void CheckInputEnter();
void GroesseAendern(int Art, RECT *Groesse);
void GroesseAnpassen(int Breite, int Hoehe);
void EinstellungenSichern();
void ChatVerbinden();
void ChatTrennen ();
void Empfangen();
void Loeschen();
void Beenden();
void Info();
BOOL CALLBACK InfoCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void Einstellungen();
BOOL CALLBACK EinstellungenCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);
void StartServer();
void GetRegValue(const char *Name, char *Wert);
void SetRegValue(const char *Name, const char *Wert);
DWORD WINAPI Server(LPVOID lpParameter);
void ServerSenden(char *Text, SOCKET *SendeSocket, int *VerbindungsZahl);
void Fehlerausgabe(const char *Text, int Typ=FEHLER_NORMAL);

//### Einstiespunkt fr das Betriebssystem
//########################################
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	//### Variablendeklarationen
    MSG message; 
	hInst=hInstance;
	HACCEL hAccel;
	DWORD UserNameLen=MAXUSERNAMELEN;
	OutputTextLen=0;
	ServerBeenden=0;
	hMainWnd=NULL;

	//### Tastenkrzel laden
	hAccel=LoadAccelerators(hInstance, "IDR_ACCELERATOR");
	//### Benutzernamen herausfinden
	GetUserName(UserName,&UserNameLen);

	//### Netzwerk aktivieren
	WSADATA WsaData;
	if (WSAStartup(0x202, &WsaData)!=0)
	{
		Fehlerausgabe("FEHLER: WS2_32.DLL konnte nicht gestartet werden!", FEHLER_X);
		WSACleanup();
		return -1;
	}
	ChatSocket=INVALID_SOCKET;

	//### Fenster anzeigen
	hMainWnd=CreateDialog(hInstance, MAKEINTRESOURCE(IDD_MAIN), NULL, (DLGPROC)ChatFensterCallBack);
	if (hMainWnd==NULL)
		return FALSE;
	
	//### Nachrichtenschleife starten
    while (GetMessage(&message, NULL, 0, 0)) 
    { 
		if (!TranslateAccelerator(hMainWnd, hAccel, &message))
        {
			TranslateMessage(&message); 
			DispatchMessage(&message); 
		}
    } 

	//### Netzwerk beenden
	WSACleanup();

    return message.wParam; 
}

//### Callbackroutine
//###################
LRESULT ChatFensterCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if (hWnd!=hMainWnd)
		hMainWnd=hWnd;

	switch (message)
	{
	//### Nachricht von Dialogelementen
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		//### Menpunkt "Einstellungen..."
		case ID_EINSTELLUNGEN:
			Einstellungen();
			return 1;
		//### Menpunkt "Beenden"
		case ID_BEENDEN:
			Beenden();
			return 1;
		//### Menpunkt "Info"
		case ID_INFO:
			Info();
			return 1;
		//### Schaltflche "Lschen"
		case IDC_LOESCHEN:
			Loeschen();
			return 1;
		//### Schaltflche "Senden"
		case IDC_SENDEN:
			Senden();
			return 1;
		//### Eingabefeld fr Text
		case IDC_INPUT:
			CheckInputEnter();
			return 0;
		//### Eingabefeld fr Servernamen
		case IDC_SERVER:
		//### Eingabefeld fr Portnummer
		case IDC_PORT:
		//### Ausgabefeld
		case IDC_OUTPUT:
			return 0;
		//### Schaltflche "Verbinden" bzw. "Trennen"
		case IDC_VERBINDEN:
			if (ChatSocket==INVALID_SOCKET)
				ChatVerbinden();
			else
				ChatTrennen();
			return 0;
		//### Optionsfeld "AutoSenden"
		case IDC_AUTO:
			UpdateAutoSenden();
			return 0;
		//### Sonstiges
		default:
			Fehlerausgabe("Hier fehlt noch was!!");
			return 0;
		}
	//### Beim ffnen des Fensters
	case WM_INITDIALOG:
		DialogInitialisieren();
		return 0;
	//### Beim Verndern der Fenstergrsse
	case WM_SIZING:
		GroesseAendern(wParam, (RECT*)lParam);
		return 0;
	//### Nach dem ndern der Fenstergrsse
	case WM_SIZE:
		GroesseAnpassen(LOWORD(lParam), HIWORD(lParam));
		return 1;
	//### Nach dem Schliessen des Fensters
	case WM_CLOSE:
		Beenden();
		return 1;
	case WM_NEUEDATEN:
		Empfangen();
		return 0;
	//### Systemmeldung, wenn wenig RAM verfgbar ist...
	case WM_COMPACTING:
		Fehlerausgabe("Das System Meldet: Arbeitsspeicher ist knapp!");
		return 0;
	//### Alle andderen Nachrichten unbehandelt lassen
	default:
		return 0;
	}
}

//### Senden von Text aus dem Eingabefeld
//#######################################
void Senden()
{
	char Input[MAXINPUT];
	char *InputStart=(char*)&Input;
	char SendeText[MAXINPUT+MAXUSERNAMELEN];
	
	//Text abfragen
	GetDlgItemText(hMainWnd, IDC_INPUT, Input, MAXINPUT);
	Input[MAXINPUT-1]='\0';

	//Unntige Leerzeichen und Enter am Anfang entfernen
	while (InputStart[0]==' ' || InputStart[0]==(char)10 || InputStart[0]==(char)13)
		InputStart++;

	//Unntige Leerzeichen und Enter am Ende entfernen
	int Pos=strlen(InputStart);
	while (Pos>0 && (InputStart[Pos-1]==' ' || InputStart[Pos-1]==(char)10 || InputStart[Pos-1]==(char)13))
		InputStart[--Pos]='\0';

	//Wenn Text nicht leer
	if (InputStart[0]!='\0')
	{
		//Text senden
		sprintf(SendeText, "%s: %s", UserName, InputStart);
		SendeText[MAXINPUT+MAXUSERNAMELEN-1]='\0';
		if (send(ChatSocket, SendeText, strlen(SendeText)+1, 0)==SOCKET_ERROR)
		{
			Fehlerausgabe("FEHLER: Es konnte nicht gesendet werden%s", FEHLER_X);
			ChatTrennen();
			return;
		}
	}
	
	//Eingabefeld lschen
	SetDlgItemText(hMainWnd,IDC_INPUT,"");
	//Cursor auf Eingabefeld setzen
	SetFocus(GetDlgItem(hMainWnd, IDC_INPUT));
}

//### Laden aller Einstellungen und Initialisieren
//################################################
void DialogInitialisieren()
{
	//Icon auf Dialog setzten
	SendMessage(hMainWnd, WM_SETICON, (WPARAM)ICON_SMALL, (LPARAM)LoadIcon(hInst, MAKEINTRESOURCE(IDI_ICON)));

	//Eingabefelder in grsse limitieren
	PostMessage(GetDlgItem(hMainWnd, IDC_INPUT),  EM_SETLIMITTEXT, (WPARAM)((MAXINPUT-1)/2), 0);
	PostMessage(GetDlgItem(hMainWnd, IDC_SERVER), EM_SETLIMITTEXT, (WPARAM)(MAXSERVERLEN-1), 0);
	PostMessage(GetDlgItem(hMainWnd, IDC_PORT),   EM_SETLIMITTEXT, (WPARAM)(MAXPORTLEN-1), 0);

	//Einstellungen laden
	//###################
	char Puffer[STRINGLEN];
	//Servereinstellungen
	GetRegValue("Server", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("Server",STANDARDSERVER);
		SetDlgItemText(hMainWnd, IDC_SERVER, STANDARDSERVER);
	}
	else
		SetDlgItemText(hMainWnd, IDC_SERVER, Puffer);

	//Porteinstellungen
	GetRegValue("Port", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("Port",STANDARDPORT);
		SetDlgItemText(hMainWnd, IDC_PORT, STANDARDPORT);
	}
	else
		SetDlgItemText(hMainWnd, IDC_PORT, Puffer);

	//AutoSenden Einstellen
	GetRegValue("AutoSenden", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("AutoSenden",STANDARDAUTOSENDEN);
		strcpy(Puffer, STANDARDAUTOSENDEN);
	}
	if (strcmp(Puffer,"True")==0)
		SendDlgItemMessage(hMainWnd, IDC_AUTO, BM_SETCHECK, (WPARAM)BST_CHECKED, (LPARAM)0);
	else
		SendDlgItemMessage(hMainWnd, IDC_AUTO, BM_SETCHECK, (WPARAM)BST_UNCHECKED, (LPARAM)0);
	UpdateAutoSenden();

	//PopUp!
	GetRegValue("PopUp!", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("PopUp!",STANDARDPOPUP);
		strcpy(Puffer, STANDARDPOPUP);
	}
	if (strcmp(Puffer,"True")==0)
		PopUp=1;
	else
		PopUp=0;
		
	//Chat-Server port checken
	GetRegValue("ServerPort", Puffer);
	if (Puffer[0]=='\0')
		SetRegValue("ServerPort", STANDARDSERVERPORT);

	//Chat-Server starten
	GetRegValue("ServerAktiv", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("ServerAktiv", STANDARDSERVERAKTIV);
		strcpy(Puffer, STANDARDSERVERAKTIV);
	}
	if (strcmp(Puffer,"True")==0)
		StartServer();
	
	//Senden deaktivieren
	EnableWindow(GetDlgItem(hMainWnd, IDC_INPUT),       FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_SENDEN),      FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_AUTO),        FALSE);
	
	//AutoConnect
	GetRegValue("AutoConnect", Puffer);
	if (Puffer[0]=='\0')
	{
		SetRegValue("AutoConnect",STANDARDAUTOCONNECT);
		strcpy(Puffer, STANDARDAUTOCONNECT);
	}
	else if (strcmp(Puffer,"True")==0)
		ChatVerbinden();
}

//### Aktualisiert den Dialog nach Klick auf "AutoSenden"
//#######################################################
void UpdateAutoSenden()
{
	if (SendMessage(GetDlgItem(hMainWnd, IDC_AUTO), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
	{
		EnableWindow(GetDlgItem(hMainWnd, IDC_SENDEN), FALSE);

		//Cursor auf Eingabefeld setzen
		SetFocus(GetDlgItem(hMainWnd, IDC_INPUT));
	}
	else
	{
		EnableWindow(GetDlgItem(hMainWnd, IDC_SENDEN), TRUE);
	}
}

//### Prft, ob im Eingabefeld ein Enter-Zeichen ist und Sendet dann
//##################################################################
void CheckInputEnter()
{
	//Wenn "AutoSenden" aktiviert ist...
	if (SendMessage(GetDlgItem(hMainWnd, IDC_AUTO), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
	{
		char InputText[MAXINPUT];
		int Pos, Geaendert;
		
		GetDlgItemText(hMainWnd,IDC_INPUT,InputText,MAXINPUT);
		Pos=0;
		//Testen, ob der Text gendert wurde
		Geaendert=strcmp(LetzteEingabe, InputText);
		strcpy(LetzteEingabe, InputText);

		if (Geaendert!=0)
		{
			//Nach Enter suchen
			while (InputText[Pos]!='\0' && InputText[Pos]!=(char)13 && InputText[Pos+1]!=(char)10) Pos++;

			//Wenn Enter gefunden wurde
			if (InputText[Pos]!='\0')
			{
				//Senden
				Senden();
			}
		}
	}
}

//### berprfung der momentanen Grssennderung
//##############################################
void GroesseAendern(int Art, RECT *Groesse)
{
	switch (Art)
	{
	case WMSZ_BOTTOM:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->bottom=Groesse->top+200;
		break;
	case WMSZ_BOTTOMLEFT:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->bottom=Groesse->top+200;
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->left=Groesse->right-250;
		break;
	case WMSZ_BOTTOMRIGHT:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->bottom=Groesse->top+200;
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->right=Groesse->left+250;
		break;
	case WMSZ_LEFT:
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->left=Groesse->right-250;
		break;
	case WMSZ_RIGHT:
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->right=Groesse->left+250;
		break;
	case WMSZ_TOP:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->top=Groesse->bottom-200;
		break;
	case WMSZ_TOPLEFT:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->top=Groesse->bottom-200;
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->left=Groesse->right-250;
		break;
	case WMSZ_TOPRIGHT:
		if (Groesse->bottom-Groesse->top<MINWINDOWY) Groesse->top=Groesse->bottom-200;
		if (Groesse->right-Groesse->left<MINWINDOWX) Groesse->right=Groesse->left+250;
		break;
	}
}

//### Nach dem ndern der Dialog-Grsse
//#####################################
void GroesseAnpassen(int Breite, int Hoehe)
{
	//1. AusgabeFeld IDC_OUTPUT
	MoveWindow(GetDlgItem(hMainWnd, IDC_OUTPUT),
		FENSTERRAND,
		FENSTERRAND+FENSTERRAND+SERVERHOEHE,
		Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-BUTTONBREITE,
		Hoehe-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-INPUTBOXHOEHE-SERVERHOEHE,TRUE);   
	//2. Eingabefeld IDC_INPUT
	MoveWindow(GetDlgItem(hMainWnd, IDC_INPUT),
		FENSTERRAND,
		Hoehe-FENSTERRAND-INPUTBOXHOEHE,
		Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-BUTTONBREITE,
		INPUTBOXHOEHE,TRUE);   

	if (AlteGroesseY>Hoehe)
	{
		//3. Lschbutton IDC_LOESCHEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_LOESCHEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			FENSTERRAND+FENSTERRAND+SERVERHOEHE,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);   
		//4. Sendebutton IDC_SENDEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_SENDEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			Hoehe-FENSTERRAND-INPUTBOXHOEHE,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);   
		//5. AutoSenden Checkbox IDC_AUTO
		MoveWindow(GetDlgItem(hMainWnd, IDC_AUTO),
			Breite-FENSTERRAND-BUTTONBREITE,
			Hoehe-FENSTERRAND-INPUTBOXHOEHE+BUTTONHOEHE+2,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);
	}
	else
	{
		//5. AutoSenden Checkbox IDC_AUTO
		MoveWindow(GetDlgItem(hMainWnd, IDC_AUTO),
			Breite-FENSTERRAND-BUTTONBREITE,
			Hoehe-FENSTERRAND-INPUTBOXHOEHE+BUTTONHOEHE+2,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);
		//4. Sendebutton IDC_SENDEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_SENDEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			Hoehe-FENSTERRAND-INPUTBOXHOEHE,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);   
		//3. Lschbutton IDC_LOESCHEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_LOESCHEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			FENSTERRAND+FENSTERRAND+SERVERHOEHE,
			BUTTONBREITE,
			BUTTONHOEHE,TRUE);   
	}

	if (AlteGroesseX>Breite)
	{
		//6. Server-Eingabefeld Label IDC_SERVERLABEL
		MoveWindow(GetDlgItem(hMainWnd, IDC_SERVERLABEL),
			FENSTERRAND,
			FENSTERRAND,
			SERVERLABELBREITE,
			SERVERHOEHE,TRUE);
		//7. Server-Eingabefeld IDC_SERVER
		MoveWindow(GetDlgItem(hMainWnd, IDC_SERVER),
			FENSTERRAND+FENSTERRAND+SERVERLABELBREITE,
			FENSTERRAND,
			Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-SERVERLABELBREITE-PORTBREITE-PORTLABELBREITE-BUTTONBREITE,
			SERVERHOEHE,TRUE);
		//8. Port-Eingabefeld Label IDC_PORTLABEL
		MoveWindow(GetDlgItem(hMainWnd, IDC_PORTLABEL),
			Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-PORTLABELBREITE-PORTBREITE-BUTTONBREITE,
			FENSTERRAND,
			PORTLABELBREITE,
			SERVERHOEHE,TRUE);
		//9. Port Eingabefeld IDC_PORT
		MoveWindow(GetDlgItem(hMainWnd, IDC_PORT),
			Breite-FENSTERRAND-FENSTERRAND-BUTTONBREITE-PORTBREITE,
			FENSTERRAND,
			PORTBREITE,
			SERVERHOEHE,TRUE);
		//10. Verbinden-Button IDC_VERBINDEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_VERBINDEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			FENSTERRAND-1,
			BUTTONBREITE,
			SERVERHOEHE,TRUE);
	}
	else
	{
		//10. Verbinden-Button IDC_VERBINDEN
		MoveWindow(GetDlgItem(hMainWnd, IDC_VERBINDEN),
			Breite-FENSTERRAND-BUTTONBREITE,
			FENSTERRAND-1,
			BUTTONBREITE,
			SERVERHOEHE,TRUE);
		//9. Port Eingabefeld IDC_PORT
		MoveWindow(GetDlgItem(hMainWnd, IDC_PORT),
			Breite-FENSTERRAND-FENSTERRAND-BUTTONBREITE-PORTBREITE,
			FENSTERRAND,
			PORTBREITE,
			SERVERHOEHE,TRUE);
		//8. Port-Eingabefeld Label IDC_PORTLABEL
		MoveWindow(GetDlgItem(hMainWnd, IDC_PORTLABEL),
			Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-PORTLABELBREITE-PORTBREITE-BUTTONBREITE,
			FENSTERRAND,
			PORTLABELBREITE,
			SERVERHOEHE,TRUE);
		//7. Server-Eingabefeld IDC_SERVER
		MoveWindow(GetDlgItem(hMainWnd, IDC_SERVER),
			FENSTERRAND+FENSTERRAND+SERVERLABELBREITE,
			FENSTERRAND,
			Breite-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-FENSTERRAND-SERVERLABELBREITE-PORTBREITE-PORTLABELBREITE-BUTTONBREITE,
			SERVERHOEHE,TRUE);
		//6. Server-Eingabefeld Label IDC_SERVERLABEL
		MoveWindow(GetDlgItem(hMainWnd, IDC_SERVERLABEL),
			FENSTERRAND,
			FENSTERRAND,
			SERVERLABELBREITE,
			SERVERHOEHE,TRUE);
	}

	AlteGroesseX=Breite;
	AlteGroesseY=Hoehe;
}

//### Sichern der Einstellungen vor dem Beenden
//#############################################
void EinstellungenSichern()
{
	char Puffer[STRINGLEN];
	GetDlgItemText(hMainWnd, IDC_SERVER, Puffer, STRINGLEN);
	SetRegValue("Server", Puffer);
	GetDlgItemText(hMainWnd, IDC_PORT, Puffer, STRINGLEN);
	SetRegValue("Port", Puffer);
	if (SendMessage(GetDlgItem(hMainWnd, IDC_AUTO), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
		SetRegValue("AutoSenden", "True");
	else
		SetRegValue("AutoSenden", "False");
	if (PopUp==1)
		SetRegValue("PopUp!", "True");
	else
		SetRegValue("PopUp!", "False");
}

//### Mit einem Chat-Server verbinden
//###################################
void ChatVerbinden()
{
	//### Servernamen auflsen
	char Server[MAXSERVERLEN];
	GetDlgItemText(hMainWnd, IDC_SERVER, Server, MAXSERVERLEN);
	hostent *Host=gethostbyname(Server);
	if (Host==NULL)
	{
		Fehlerausgabe("FEHLER: Servername konnte nicht aufgelst werden%s", FEHLER_AUSRUFEZEICHEN);
		return;
	}
	
	//### Socket starten
	ChatSocket=socket(AF_INET, SOCK_STREAM, 0);
	if (ChatSocket==INVALID_SOCKET)
	{
		Fehlerausgabe("FEHLER: Es konnte keine Netzwerkverbindung aktiviert werden%s", FEHLER_X);
		return;
	}

	char Port[MAXPORTLEN];
	GetDlgItemText(hMainWnd, IDC_PORT, Port, MAXPORTLEN);
	sockaddr_in Ziel;
	Ziel.sin_family=AF_INET;
	Ziel.sin_port=htons((unsigned short)atoi(Port));
	Ziel.sin_addr=*((in_addr*)Host->h_addr);
	
	//### Verbinden
	if (connect(ChatSocket, (sockaddr*)&Ziel, sizeof(Ziel))==SOCKET_ERROR)
	{
		Fehlerausgabe("FEHLER: Verbindung zum Server konnte nicht erstellt werden%s", FEHLER_X);
		closesocket(ChatSocket);
		ChatSocket=INVALID_SOCKET;
		return;
	}

	//### Automatische Benachrichtigung bei einkommenden Daten aktivieren
	if (WSAAsyncSelect(ChatSocket, hMainWnd, WM_NEUEDATEN, FD_READ)==SOCKET_ERROR)
	{
		Fehlerausgabe("FEHLER: Automatische Benachrichtigung konnte nicht aktiviert werden%s", FEHLER_X);
		shutdown(ChatSocket, SD_BOTH);
		closesocket(ChatSocket);
		ChatSocket=INVALID_SOCKET;
		return;
	}

	//### Dialog aktualisieren
	SetDlgItemText(hMainWnd, IDC_VERBINDEN, "&Trennen");
	EnableWindow(GetDlgItem(hMainWnd, IDC_SERVERLABEL), FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_SERVER),      FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_PORTLABEL),   FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_PORT),        FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_INPUT),       TRUE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_AUTO),        TRUE);
	UpdateAutoSenden();

	//Cursor auf Eingabefeld setzen
	SetFocus(GetDlgItem(hMainWnd, IDC_INPUT));
}

//### Trennt die Verbindung von einem Chat
//########################################
void ChatTrennen ()
{
	//### Automatische Benachrichtigung deaktivieren
	if (WSAAsyncSelect(ChatSocket, hMainWnd, WM_NEUEDATEN, 0)==SOCKET_ERROR)
		Fehlerausgabe("FEHLER: Automatische Benachrichtigung konnte nicht deaktiviert werden%s", FEHLER_X);

	//### Trennen
	if (shutdown(ChatSocket, SD_BOTH)==SOCKET_ERROR)
		Fehlerausgabe("FEHLER: Verbindung zum Server konnte nicht geschlossen werden%s", FEHLER_X);

	if (closesocket(ChatSocket)==SOCKET_ERROR)
		Fehlerausgabe("FEHLER: Netzwerkverbindung konnte nicht geschlossen werden%s", FEHLER_X);

	ChatSocket=INVALID_SOCKET;

	//### Dialog aktualisieren
	SetDlgItemText(hMainWnd, IDC_VERBINDEN, "&Verbinden");
	EnableWindow(GetDlgItem(hMainWnd, IDC_SERVERLABEL), TRUE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_SERVER),      TRUE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_PORTLABEL),   TRUE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_PORT),        TRUE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_INPUT),       FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_SENDEN),      FALSE);
	EnableWindow(GetDlgItem(hMainWnd, IDC_AUTO),        FALSE);

	//Cursor auf Server-Eingabefeld setzen
	SetFocus(GetDlgItem(hMainWnd, IDC_SERVER));
}

//### Empfngt Daten aus dem Netzwerk, nachdem neue angekommen sind
//#################################################################
void Empfangen()
{
	int DataLen;
	char Data[(MAXINPUT+MAXUSERNAMELEN)*2];

	//Daten aus dem Puffer kopieren
	DataLen=recv(ChatSocket, Data, (MAXINPUT+MAXUSERNAMELEN)*2, 0);
	switch (DataLen)
	{
	case SOCKET_ERROR:
		Fehlerausgabe("FEHLER: Fehler beim Empfangen%s", FEHLER_X);
		ChatTrennen();
		break;
	case 0:
		Fehlerausgabe("FEHLER: Verbindung wurde getrennt!", FEHLER_AUSRUFEZEICHEN);
		ChatTrennen();
		break;
	default:
		//Daten ins Ausgabefeld schreiben
		char *NeuerOutput=new char[(OutputTextLen+DataLen)*4];
		
		GetDlgItemText(hMainWnd, IDC_OUTPUT, NeuerOutput, OutputTextLen+4);

		if (OutputTextLen>0)
		{
			NeuerOutput[OutputTextLen-1]=(char)13;
			NeuerOutput[OutputTextLen]=(char)10;
			NeuerOutput[OutputTextLen+1]='\0';
			OutputTextLen=OutputTextLen+DataLen+1;
		}
		else
			OutputTextLen=DataLen;

		strcat(NeuerOutput, Data);

		//Text setzten
		SetDlgItemText(hMainWnd, IDC_OUTPUT, NeuerOutput);
		//Ans Ende der Liste Scrollen
		SendDlgItemMessage(hMainWnd, IDC_OUTPUT, EM_LINESCROLL, 0, 2147483647);

		delete NeuerOutput;

		//Fenster aufpoppen lassen...
		//(in Win98 und 2000 blinkt nur die Taskleiste!)
		if (PopUp==1)
		{
			if (IsIconic(hMainWnd)==TRUE)
				OpenIcon(hMainWnd);
			else
				SetForegroundWindow(hMainWnd);
		}

		break;
	}
}

//### Lscht das Ausgabefenster
//#############################
void Loeschen()
{
	SetDlgItemText(hMainWnd, IDC_OUTPUT, "");
	OutputTextLen=0;

	//Cursor auf Eingabefeld setzen
	SetFocus(GetDlgItem(hMainWnd, IDC_INPUT));
}

//### Beendet den Chat
//####################
void Beenden()
{
	EinstellungenSichern();
	if (ChatSocket!=INVALID_SOCKET)
		ChatTrennen();
	PostQuitMessage(0);
}

//### Zeigt die Info an
//#####################
void Info()
{
	DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hMainWnd, InfoCallBack);
}

BOOL CALLBACK InfoCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDOK:
				EndDialog(hWnd, LOWORD(wParam));
				return TRUE;
			}
	}
    return FALSE;
}

//### Zeigt die Einstellungen an
//##############################
void Einstellungen()
{
	DialogBox(hInst, MAKEINTRESOURCE(IDD_EINSTELLUNGEN), hMainWnd, EinstellungenCallBack);
}

BOOL CALLBACK EinstellungenCallBack(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message)
	{
		case WM_INITDIALOG:
			//### Einstellungen fr Dialog vornehmen:
			
			//PopUP!
			if (PopUp==1)
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_POPUP, BM_SETCHECK, (WPARAM)BST_CHECKED, (LPARAM)0);
			else
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_POPUP, BM_SETCHECK, (WPARAM)BST_UNCHECKED, (LPARAM)0);

			//AutoConnect
			char Puffer[STRINGLEN];
			GetRegValue("AutoConnect", Puffer);
			if (strcmp(Puffer,"True")==0)
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_AUTOCONNECT, BM_SETCHECK, (WPARAM)BST_CHECKED, (LPARAM)0);
			else
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_AUTOCONNECT, BM_SETCHECK, (WPARAM)BST_UNCHECKED, (LPARAM)0);

			//ServerPort
			PostMessage(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_PORT), EM_SETLIMITTEXT, (WPARAM)(MAXPORTLEN-1), 0);
			GetRegValue("ServerPort", Puffer);
			SetDlgItemText(hWnd, IDC_EINSTELLUNGEN_PORT, Puffer);

			//ServerAktiv
			GetRegValue("ServerAktiv", Puffer);
			if (strcmp(Puffer,"True")==0)
			{
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_SERVERAKTIV, BM_SETCHECK, (WPARAM)BST_CHECKED, (LPARAM)0);
				EnableWindow(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_PORT), TRUE);
			}
			else
			{
				SendDlgItemMessage(hWnd, IDC_EINSTELLUNGEN_SERVERAKTIV, BM_SETCHECK, (WPARAM)BST_UNCHECKED, (LPARAM)0);
				EnableWindow(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_PORT), FALSE);
			}
			return TRUE;
		case WM_COMMAND:
			switch (LOWORD(wParam))
			{
			case IDOK:
				//### Einstellungen setzen & sichern
				
				//PopUP!
				if (SendMessage(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_POPUP), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
					PopUp=1;
				else
					PopUp=0;

				//AutoConnect
				if (SendMessage(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_AUTOCONNECT), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
					SetRegValue("AutoConnect", "True");
				else
					SetRegValue("AutoConnect", "False");

				//ServerAktiv
				char Puffer[MAXPORTLEN];
				if (SendMessage(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_SERVERAKTIV), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
				{
					SetRegValue("ServerAktiv", "True");

					//ServerPort
					GetDlgItemText(hWnd, IDC_EINSTELLUNGEN_PORT, Puffer, MAXPORTLEN);
					int PortNo=atoi(Puffer);
					if (PortNo<1024 || PortNo>65536)
					{
						Fehlerausgabe("Bitte eine Zahl zwischen 1024 und 65535 fr den Port eingeben!", FEHLER_AUSRUFEZEICHEN);
						return FALSE;
					}
					else
					{
						char Puffer2[MAXPORTLEN];
						GetRegValue("ServerPort", Puffer2);
						if (atoi(Puffer)!=atoi(Puffer2))
						{
							SetRegValue("ServerPort", Puffer);
							Fehlerausgabe("nderungen am Server-Port werden erst nach einem Neustart des Chats wirksam.", FEHLER_AUSRUFEZEICHEN);
						}
					}
				}
				else
					SetRegValue("ServerAktiv", "False");

			case IDCANCEL:
				EndDialog(hWnd, LOWORD(wParam));
				return TRUE;
			case IDC_EINSTELLUNGEN_SERVERAKTIV:
				if (SendMessage(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_SERVERAKTIV), BM_GETCHECK, (WPARAM)0, (LPARAM)0)==BST_CHECKED)
					EnableWindow(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_PORT), TRUE);
				else
					EnableWindow(GetDlgItem(hWnd, IDC_EINSTELLUNGEN_PORT), FALSE);
				return TRUE;
			}
	}
    return FALSE;
}

//### Aktiviert die Serverkomponente im Programm
//##############################################
void StartServer()
{
	unsigned long ThreadID;
	if (CreateThread(NULL, 0, Server, NULL, 0, &ThreadID)==NULL)
		Fehlerausgabe("Konnte Server-Thread nicht starten!", FEHLER_X);
}

//### Holt einen Wert aus der Registrierung
//#########################################
void GetRegValue(const char *Name, char *Wert)
{
	HKEY ChatRegKey;

	if (RegCreateKey(HKEY_CURRENT_USER, REGVERZEICHNIS, &ChatRegKey)!=ERROR_SUCCESS)
	{
		Wert[0]='\0';
		return;
	}

	DWORD RegWertTyp;
	DWORD StringLen;
	StringLen=STRINGLEN;

	if (RegQueryValueEx(ChatRegKey, Name, NULL, &RegWertTyp, (unsigned char*)Wert, &StringLen)!=ERROR_SUCCESS)
	{
		Wert[0]='\0';
		return;
	}
}

//### Setzt einen Wert in die Registrierung
//#########################################
void SetRegValue(const char *Name, const char *Wert)
{
	HKEY ChatRegKey;

	if (RegCreateKey(HKEY_CURRENT_USER, REGVERZEICHNIS, &ChatRegKey)!=ERROR_SUCCESS)
	{
		return;
	}
	RegSetValueEx(ChatRegKey, Name, 0, REG_SZ, (unsigned char*)Wert, strlen(Wert));
}

//### Chat-Server-Thread-Routine
//##############################
DWORD WINAPI Server(LPVOID lpParameter)
{
	//Variablen anlegen
	char Puffer[MAXINPUT+MAXUSERNAMELEN];
	int j;
	fd_set InputSocketSet;
	fd_set FehlerSocketSet;
	timeval WarteZeit;
	WarteZeit.tv_sec=0;
	WarteZeit.tv_usec=250000;
	SOCKET Verbindungen[FD_SETSIZE+1];
	for (int i=0;i<FD_SETSIZE;i++) 
		Verbindungen[i]=INVALID_SOCKET;
	sockaddr_in Adressen[FD_SETSIZE+1];
	int VerbindungsZahl=0;
	int PufferLen;
	int AdressLen=sizeof(Adressen[0]);

	//### Socket fr einkommende Verbindungen einrichten
	Verbindungen[0]=socket(AF_INET, SOCK_STREAM, 0);
	if (Verbindungen[0]==INVALID_SOCKET)
	{
		Fehlerausgabe("Das Server-Socket konnte nicht gestartet werden%s", FEHLER_X);
		return 1;
	}

	//### Frisches Socket auf einen Port binden
	sockaddr_in LokalesSocket;
	GetRegValue("ServerPort", Puffer);
	LokalesSocket.sin_family=AF_INET;
	LokalesSocket.sin_port=htons((unsigned short)atoi(Puffer));
	LokalesSocket.sin_addr.s_addr=INADDR_ANY;
	if (bind(Verbindungen[0], (sockaddr*)&LokalesSocket, sizeof(LokalesSocket))==SOCKET_ERROR)
	{
		Fehlerausgabe("Das Server-Socket konnte nicht auf den angegebenen Port gebunden werden%s", FEHLER_X);
		return 1;
	}
	
	//### Jetzt nur noch "Zuhren" einstellen
	if (listen(Verbindungen[0], MAXBACKLOG)==SOCKET_ERROR)
	{
		Fehlerausgabe("FEHLER: listen() konnte nicht gestartet werden%s", FEHLER_X);
		return 1;
	}

	//############################
	//### ChatServer laufen lassen
	//############################
	while (ServerBeenden!=1)
	{
		//FD_SETs Vorbereiten
		FD_ZERO(&InputSocketSet);
		FD_ZERO(&FehlerSocketSet);
		for (int i=0;i<FD_SETSIZE;i++)
		{
			if (Verbindungen[i]!=INVALID_SOCKET)
			{
				FD_SET(Verbindungen[i], &InputSocketSet);
				FD_SET(Verbindungen[i], &FehlerSocketSet);
			}
		}
		
		//Wartezeit auf Regung warten
		if (select(0, &InputSocketSet, NULL, &FehlerSocketSet, &WarteZeit)==SOCKET_ERROR)
		{
			Fehlerausgabe("Fehler beim ChatServer: select() gescheitert%s", FEHLER_X);
			return 1;
		}
		else
		{
			//### Neu ankommende Verbindung verarbeiten
			//#########################################
			if (FD_ISSET(Verbindungen[0], &InputSocketSet))
			{
				//Wenn zu viele Verbindungen, dann Abweisen
				if (VerbindungsZahl+1>=FD_SETSIZE)
				{
					Verbindungen[FD_SETSIZE]=accept(Verbindungen[0],(sockaddr*)&Adressen[FD_SETSIZE], &AdressLen);
					send(Verbindungen[FD_SETSIZE], "Sorry, Zu viele Verbindungen auf diesem Chat-Server!\0x0D\0x0A",19,0);
					shutdown(Verbindungen[FD_SETSIZE], SD_BOTH);
					closesocket(Verbindungen[FD_SETSIZE]);
					break;
				}
				else
				{
					//Nchstes Freies Socket suchen
					i=1;
					while (i<FD_SETSIZE-1 && Verbindungen[i]!=INVALID_SOCKET) i++;
					//Verbindung annehmen
					Verbindungen[i]=accept(Verbindungen[0],(sockaddr*)&Adressen[i], &AdressLen);
					if (Verbindungen[i]==INVALID_SOCKET)
					{
						Fehlerausgabe("FEHLER beim Chat-Server: accept() ist fehlgeschlagen%s", FEHLER_X);
						break;
					}
					else
					{
						VerbindungsZahl++;
						sprintf(Puffer,"Verbindung von %d.%d.%d.%d erhalten.\0x0D\0x0A", Adressen[i].sin_addr.S_un.S_un_b.s_b1, Adressen[i].sin_addr.S_un.S_un_b.s_b2, Adressen[i].sin_addr.S_un.S_un_b.s_b3, Adressen[i].sin_addr.S_un.S_un_b.s_b4);
						//Clients benachrichtigen
						for (j=1;j<FD_SETSIZE;j++)
							if (Verbindungen[j]!=INVALID_SOCKET)
								ServerSenden(Puffer, &Verbindungen[j], &VerbindungsZahl);
					}
				}
			}
			
			//### Datenverarbeiten, die ein Client gesendet hat
			//#################################################
			for (i=1;i<FD_SETSIZE;i++)
			{
				if (FD_ISSET(Verbindungen[i], &InputSocketSet))
				{
					PufferLen=recv(Verbindungen[i], Puffer, MAXINPUT+MAXUSERNAMELEN, 0);
					switch (PufferLen)
					{
					case 0:
						//### Verbindung vom Client getrennt
						shutdown(Verbindungen[i], SD_BOTH);
						closesocket(Verbindungen[i]);
						Verbindungen[i]=INVALID_SOCKET;
						VerbindungsZahl--;
						//Clients benachrichtigen
						sprintf(Puffer,"Verbindung von %d.%d.%d.%d geschlossen.\0x0D\0x0A", Adressen[i].sin_addr.S_un.S_un_b.s_b1, Adressen[i].sin_addr.S_un.S_un_b.s_b2, Adressen[i].sin_addr.S_un.S_un_b.s_b3, Adressen[i].sin_addr.S_un.S_un_b.s_b4);
						for (j=1;j<FD_SETSIZE;j++)
							if (Verbindungen[j]!=INVALID_SOCKET)
								ServerSenden(Puffer, &Verbindungen[j], &VerbindungsZahl);
						break;
					case SOCKET_ERROR:
						//### Verbindung zusammengebrochen
						shutdown(Verbindungen[i], SD_BOTH);
						closesocket(Verbindungen[i]);
						Verbindungen[i]=INVALID_SOCKET;
						VerbindungsZahl--;
						Fehlerausgabe("ChatServer: Socket Error%s",FEHLER_X);
						break;
					default:
						//### Daten an andere Verteilen
						Puffer[PufferLen]='\0';
						for (j=1;j<FD_SETSIZE;j++)
							if (Verbindungen[j]!=INVALID_SOCKET)
								ServerSenden(Puffer, &Verbindungen[j], &VerbindungsZahl);
						break;
					}
				}
			}
			
			//### Fehlerhafte Sockets
			//#######################
			
			//### Fehlerhaftes Socket fr eingehende Verbindungen
			if (FD_ISSET(Verbindungen[0], &FehlerSocketSet))
			{
				//Socket schliessen
				shutdown(Verbindungen[0], SD_BOTH);
				closesocket(Verbindungen[0]);
				Verbindungen[0]=INVALID_SOCKET;
				//Meldung an alle Clients senden
				for (int j=1;j<FD_SETSIZE;j++)
					if (Verbindungen[j]!=INVALID_SOCKET)
						ServerSenden("Serverfehler! (Socket ist Fehlerhaft!)\0x0D\0x0A", &Verbindungen[j], &VerbindungsZahl);
			}
			//### Fehlerhafte Verbindung zu einem Client
			for (i=1;i<FD_SETSIZE;i++)
			{
				if (FD_ISSET(Verbindungen[i], &FehlerSocketSet))
				{
					shutdown(Verbindungen[i], SD_BOTH);
					closesocket(Verbindungen[i]);
					Verbindungen[i]=INVALID_SOCKET;
					sprintf(Puffer,"Verbindung von %d.%d.%d.%d produzierte Fehler.\0x0D\0x0A", Adressen[i].sin_addr.S_un.S_un_b.s_b1, Adressen[i].sin_addr.S_un.S_un_b.s_b2, Adressen[i].sin_addr.S_un.S_un_b.s_b3, Adressen[i].sin_addr.S_un.S_un_b.s_b4);
					//Clients benachrichtigen
					for (j=1;j<FD_SETSIZE;j++)
						if (Verbindungen[j]!=INVALID_SOCKET)
							ServerSenden(Puffer, &Verbindungen[j], &VerbindungsZahl);
				}
			}
		}
	}

	//### Beenden des Servers
	//#######################

	//Alle Verbindungen Trennen
	for (i=1;i<FD_SETSIZE;i++)
	{
		if (Verbindungen[i]!=INVALID_SOCKET)
		{
			ServerSenden("Server wird beendet.\0x0D\0x0A", &Verbindungen[i], &VerbindungsZahl);
			shutdown(Verbindungen[i], SD_BOTH);
			closesocket(Verbindungen[i]);
			Verbindungen[i]=INVALID_SOCKET;
		}
	}
	
	//Ende
	shutdown(Verbindungen[0], SD_BOTH);
	closesocket(Verbindungen[0]);

	ServerBeenden=2;
	return 0;
}

//### Sendet eine Nachricht an ein Socket
//#######################################
void ServerSenden(char *Text, SOCKET *SendeSocket, int *VerbindungsZahl)
{
	if (send(*SendeSocket, Text, strlen(Text)+1, 0)==SOCKET_ERROR)
	{
		shutdown(*SendeSocket, SD_BOTH);
		closesocket(*SendeSocket);
		*SendeSocket=INVALID_SOCKET;
		VerbindungsZahl--;
		Fehlerausgabe("Chat-Server: Konnte nicht senden%S", FEHLER_X);
	}
}

//### Gibt einen Fehler aus
//#########################
void Fehlerausgabe(const char *Text, int Typ)
{
	char Puffer[FEHLERSTRINGLEN];
	switch (WSAGetLastError())
	{
		case WSAEADDRINUSE:			sprintf(Puffer, Text, ":\n\nThe socket's local address is already in use and the socket was not marked to allow address reuse with SO_REUSEADDR. This error usually occurs during execution of the bind function, but could be delayed until this function if the bind was to a partially wild-card address (involving ADDR_ANY) and if a specific address needs to be \"committed\" at the time of this function.");break;	
		case WSAEADDRNOTAVAIL:		sprintf(Puffer, Text, ":\n\nThe specified address is not a valid address for this machine");break;		
		case WSAEAFNOSUPPORT:		sprintf(Puffer, Text, ":\n\nAddresses in the specified family cannot be used with this socket.");break;		
		case WSAEALREADY:			sprintf(Puffer, Text, ":\n\nA nonblocking connect call is in progress on the specified socket.");break;	
		case WSAECONNABORTED:		sprintf(Puffer, Text, ":\n\nThe virtual circuit was terminated due to a time-out or other failure. The application should close the socket as it is no longer usable.");break;		
		case WSAECONNREFUSED:		sprintf(Puffer, Text, ":\n\nThe attempt to connect was forcefully rejected.");break;		
		case WSAECONNRESET:			sprintf(Puffer, Text, ":\n\nThe virtual circuit was reset by the remote side executing a \"hard\" or \"abortive\" close. For UPD sockets, the remote host was unable to deliver a previously sent UDP datagram and responded with a \"Port Unreachable\" ICMP packet. The application should close the socket as it is no longer usable.");break;	
		case WSAEFAULT:				sprintf(Puffer, Text, ":\n\nAn parameter is not a valid.");break;
		case WSAEHOSTUNREACH:		sprintf(Puffer, Text, ":\n\nThe remote host cannot be reached from this host at this time.");break;		
		case WSAEINVAL:				sprintf(Puffer, Text, ":\n\nError in Parameter Value.");break;
		case WSAEISCONN:			sprintf(Puffer, Text, ":\n\nThe socket is already connected (connection-oriented sockets only).");break;	
		case WSAEMFILE:				sprintf(Puffer, Text, ":\n\nNo more socket descriptors are available.");break;
		case WSAENETDOWN:			sprintf(Puffer, Text, ":\n\nThe network subsystem has failed.");break;	
		case WSAENETRESET:			sprintf(Puffer, Text, ":\n\nThe connection has been broken due to the \"keep-alive\" activity detecting a failure while the operation was in progress.");break;	
		case WSAENETUNREACH:		sprintf(Puffer, Text, ":\n\nThe specified destination is no longer reachable");break;		
		case WSAENOBUFS:			sprintf(Puffer, Text, ":\n\nNo buffer space is available.");break;	
		case WSAENOTCONN:			sprintf(Puffer, Text, ":\n\nThe socket is not connected.");break;	
		case WSAENOTSOCK:			sprintf(Puffer, Text, ":\n\nThe descriptor is not a socket.");break;	
		case WSAEOPNOTSUPP:			sprintf(Puffer, Text, ":\n\nThe referenced socket is not a type that supports connection-oriented service.");break;	
		case WSAEPROCLIM:			sprintf(Puffer, Text, ":\n\nLimit on the number of tasks supported by the Windows Sockets implementation has been reached.");break;	
		case WSAEPROTONOSUPPORT:	sprintf(Puffer, Text, ":\n\nThe specified protocol is not supported.");break;			
		case WSAEPROTOTYPE:			sprintf(Puffer, Text, ":\n\nThe specified protocol is the wrong type for this socket.");break;	
		case WSAESHUTDOWN:			sprintf(Puffer, Text, ":\n\nThe socket has been shut down; it is not possible to send on a socket after shutdown has been invoked with how set to SD_SEND or SD_BOTH.");break;	
		case WSAESOCKTNOSUPPORT:	sprintf(Puffer, Text, ":\n\nThe specified socket type is not supported in this address family.");break;			
		case WSAETIMEDOUT:			sprintf(Puffer, Text, ":\n\nThe connection has been dropped, because of a network failure or because the system on the other end went down without notice.");break;	
		case WSAHOST_NOT_FOUND:		sprintf(Puffer, Text, ":\n\nAuthoritative Answer Host not found.");break;
		case WSANO_DATA:			sprintf(Puffer, Text, ":\n\nValid name, no data record of requested type.");break;
		case WSASYSNOTREADY:		sprintf(Puffer, Text, ":\n\nThe underlying network subsystem is not ready for network communication.");break;
		case WSATRY_AGAIN:			sprintf(Puffer, Text, ":\n\nNon-Authoritative Host not found, or server failure.");break;
		case WSAVERNOTSUPPORTED:	sprintf(Puffer, Text, ":\n\nThe version of Windows Sockets support requested is not provided by this particular Windows Sockets implementation.");break;
		default:					sprintf(Puffer, Text);
	}
	switch (Typ)
	{
	case FEHLER_NORMAL:
		Typ=MB_OK;
		break;
	case FEHLER_AUSRUFEZEICHEN:
		Typ=MB_OK|MB_ICONEXCLAMATION;
		break;
	case FEHLER_X:
		Typ=MB_OK|MB_ICONERROR;
		break;
	case FEHLER_FRAGEZEICHEN:
		Typ=MB_OK|MB_ICONINFORMATION;
		break;
	}
	MessageBox(hMainWnd, Puffer, "Chat", Typ);
}